#ifndef KEYWORDS_H
#define KEYWORDS_H

#include "lexer.h"

static TokenType check_keyword(int start, int length, const char *rest, TokenType type) {
  if ((lexer.current - lexer.start) == start + length &&
      memcmp(lexer.start + start, rest, length) == 0) return type;
  return TOKEN_IDENTIFIER;
}

static TokenType identifier_type(void) {
  switch (lexer.start[0]) {
    case 'c':
      return check_keyword(1, 4, "onst", TOKEN_KEYWORD_CONST);
    case 'e':
      return check_keyword(1, 3, "lse", TOKEN_KEYWORD_ELSE);
    case 'f':
      return check_keyword(1, 1, "n", TOKEN_KEYWORD_FN);
      return check_keyword(1, 2, "or", TOKEN_KEYWORD_FOR);
    case 'i':
      return check_keyword(1, 1, "f", TOKEN_KEYWORD_IF);
      return check_keyword(1, 1, "s", TOKEN_OPERATOR_IS);
    case 'l':
      return check_keyword(1, 2, "et", TOKEN_KEYWORD_LET);
    case 'r':
      return check_keyword(1, 5, "eturn", TOKEN_KEYWORD_RETURN);
    case 't':
      return check_keyword(1, 3, "ype", TOKEN_KEYWORD_TYPE);
    case 'u':
      return check_keyword(1, 2, "se", TOKEN_KEYWORD_USE);
    case 'w':
      return check_keyword(1, 4, "hile", TOKEN_KEYWORD_WHILE);
  }
  return TOKEN_IDENTIFIER;
}

#endif // KEYWORDS_H
